SystemOrganization addCategory: #MkBuffonsNeedle!

Object subclass: #BuffonExperimentSeries
	instanceVariableNames: 'n hits'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MkBuffonsNeedle'!

!BuffonExperimentSeries class methodsFor: 'instance creation' stamp: 'MathiasKegelmann 8/30/2010 22:23'!
new: numberOfThrows
	| bes |
	bes := BuffonExperimentSeries basicNew.
	bes initialize: numberOfThrows.
	^ bes.! !

!BuffonExperimentSeries methodsFor: 'initialization' stamp: 'MathiasKegelmann 8/30/2010 22:22'!
initialize: numberOfThrows
	n := numberOfThrows.
! !

!BuffonExperimentSeries methodsFor: 'accessing' stamp: 'MathiasKegelmann 8/30/2010 22:30'!
ratio
	^ (hits / n) asFloat.! !

!BuffonExperimentSeries methodsFor: 'running' stamp: 'MathiasKegelmann 8/30/2010 22:27'!
run
	hits := 0.
	n timesRepeat: [ 
		| experiment |
		experiment := BuffonThrow  atRandom.
		experiment isCrossing ifTrue: [ hits := hits + 1].
		].
	! !

!BuffonExperimentSeries methodsFor: 'accessing' stamp: 'MathiasKegelmann 8/30/2010 22:30'!
twoOverPi
	^ 2 / Float pi.! !

Object subclass: #BuffonThrow
	instanceVariableNames: 'x angle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MkBuffonsNeedle'!

!BuffonThrow commentStamp: '<historical>' prior: 0!
I simulate one thrown needle of unit length.

x - x coordinate taken from [0, 1[
angle - angle in degrees!

!BuffonThrow class methodsFor: 'instance creation' stamp: 'MathiasKegelmann 8/30/2010 22:03'!
at: position withAngle: a
	"Create an instance with the given parameters"
	| t |
	t := BuffonThrow basicNew.
	t initializeWith: position andAngle: a.
	^t.! !

!BuffonThrow class methodsFor: 'instance creation' stamp: 'MathiasKegelmann 8/30/2010 22:11'!
atRandom
	"Create a random throw."
	| random |
	random := Random new.
	^ self at: (random next) withAngle: (random next * 360).
	! !

!BuffonThrow methodsFor: 'initialization' stamp: 'MathiasKegelmann 8/30/2010 22:03'!
initializeWith: position andAngle: a
	x := position.
	angle := a.
	! !

!BuffonThrow methodsFor: 'testing' stamp: 'MathiasKegelmann 8/30/2010 22:20'!
isCrossing
	"does this needle cross a crack"
	| x2 |
	x2 := x + (angle / 360 * Float twoPi) sin.
	^ (x = 0) | (x2 <= 0) | (x2 >= 1). ! !
